<?
/*
разделить строку на корни, окончания и символы: 
prepare_str($str)

Нужно иметь:
header("Expires: Tue, 1 Jul 2003 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Pragma: no-cache");
header('Content-Type: text/html; charset=UTF-8');
setlocale(LC_ALL, "ru_RU.UTF-8");
mb_http_input('UTF-8');
mb_http_output('UTF-8');
mb_internal_encoding("UTF-8");

Нужно включить:
include_once($_SERVER["DOCUMENT_ROOT"]."/lib/separate_str.php");
include_once($_SERVER["DOCUMENT_ROOT"]."/lib/indexer_stemmer_UTF8.php");
$stemmer = new Lingua_Stem_Ru();

*/

// $core_only=1 - выдавать только корни
function prepare_str($text,$core_only=0)
{
global $sArr,$stemmer;
// выделить слова
$text=mb_strtolower($text);  // exit("! $text");

// не здесь $text=str_replace('-',' ',$text);

//$text=preg_replace('/[^а-яА-Я ]/','',$text);
$text=preg_replace('/\r\n/','|##|',$text); 
$text=preg_replace('/\s/','|#|',$text);

$text=preg_replace('/[^|а-яa-z0-9\!\?\@\#\$\%\^\&\*\(\)\+\=\-1234567890\[\]\{\}\<\>\.\,\/ ]/u','',$text);
//$text=preg_replace('/[^абвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯabcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\!\?\@\#\$\%\^\&\*\(\)\+\=\-1234567890\[\]\{\}\<\>\.\,\/ /','',$text);

$text=str_replace(' ','',$text);
$text=str_replace('|#|',' ',$text);   //exit("!!!! $text");
$text=str_replace('|##|',"\r\n",$text);

// разбить на слова и символы
$wordArr=array();
$str="";
$save=0;
for($n=0;$n<strlen($text);$n++)
{
if($text[$n]==' ' ||$text[$n]=='.' ||$text[$n]==',' || $text[$n]=='!' ||$text[$n]=='?' ||ord($text[$n])==13 ||$text[$n]=='(' ||$text[$n]==')' ||$text[$n]=='[' ||$text[$n]==']' )
{
$str=trim($str);
if(!empty($str))// если это не одно слово
{
	array_push($wordArr,$str);
	$save=1;
}
if($text[$n]==' ' ||$text[$n]=='.' ||$text[$n]==',' || $text[$n]=='!' ||$text[$n]=='?' ||$text[$n]=='(' ||$text[$n]==')' ||$text[$n]=='[' ||$text[$n]==']' )
{
array_push($wordArr,$text[$n]);// записать знак тоже !!!В ТОМ ЧИСЛЕ ПРОБЕЛ!!!!
$save=1;
}
$str="";
$save=0;
continue;
}

$str.=$text[$n];
}
//exit("!!! $save | ".$str);
if(!$save)
array_push($wordArr,$str);
//var_dump($wordArr);exit();

// разбить на корни, окончания и выдать в такой последовательности

$n=0;
foreach($wordArr as $w)
{ 
if($n>900)
	{
array_push($sArr,"XXXXX900xxxxx");
break;
	}

//$w=trim($w);	
//	exit("!!!! |$w| ".strlen($w));
if(mb_strlen($w)==1)// отдельные символы
	{ 
array_push($sArr,$w);
continue;
	}
////////////////////

// слова с тире: все-таки так-то все-все
if(strpos($w,"-")!==false)// разделить на отдельные слова и отдельно '-'
{ //exit("$w");
$list=explode("-",$w); //var_dump($list);exit();
$m=0;
foreach($list as $s)
{ 
if($m)
array_push($sArr,"-");
$res=separate($s,$core_only);
if(!$res)
	continue;
$n++;
$m++;
}
continue;
}

// нормальные слова
$res=separate($w,$core_only);
if(!$res)
	continue;

$n++;
}
//var_dump($sArr);exit();

return $sArr;
}
////////////////////////
function separate($w,$core_only)
{
global $sArr,$stemmer;

$core =$stemmer->stem_word($w);  
//$core=preg_replace('/[^а-яА-Я]/','',$core);
if(empty($core))
	return 0;

array_push($sArr,$core);  // exit("! $w | $core");
if(!$core_only)
{
if(mb_strlen($w,'UTF-8') > mb_strlen($core,'UTF-8'))
{ 
$len1=mb_strlen($w,'UTF-8');
$len2=mb_strlen($core,'UTF-8');
$end=mb_substr($w,$len2,$len1-$len2,'UTF-8'); 
//exit("$w | $core | $end <br> $len1 | $len2 <br>".mb_strlen($core,'UTF-8'));
array_push($sArr,$end);
}
}
return 1;
}
//////////////////////////////
?>